## blas 1.2.20110419

=== cblas/Makefile ===
dlvl = ./.
include $(dlvl)/Makefile.in
help:
	@ echo "Make sure you are using correct Makefile.in for your system."
	@ echo "At this level, assuming you have downloded all necessary    "
	@ echo "files and made an archive file of BLAS routines for your    "
	@ echo "system."
	@ echo " "
	@ echo "The Makefile compiles the routines of CBLAS (C interface of "
	@ echo "BLAS) and testers for all the precisions.                   "
	@ echo "If there is no directory for archives in CBLAS/lib, it      "
	@ echo "creates new directory with the name of the platform of your "
	@ echo "machine." 
	@ echo " "
	@ echo "To compile, you have to type as follows"
	@ echo "make <target>"
	@ echo " where <target> is one of:"
	@ echo "slib1 --- make an archive of level 1 REAL."
	@ echo "dlib1 --- make an archive of level 1 DOUBLE PRECISION."
	@ echo "clib1 --- make an archive of level 1 COMPLEX."
	@ echo "zlib1 --- make an archive of level 1 COMPLEX*16."
	@ echo "alllib1 - make an archive of level 1 all precisions."
	@ echo " "
	@ echo "slib2 --- make an archive of level 2 REAL."
	@ echo "dlib2 --- make an archive of level 2 DOUBLE PRECSION."
	@ echo "clib2 --- make an archive of level 2 COMPLEX."
	@ echo "zlib2 --- make an archive of level 2 COMPLEX*16."
	@ echo "alllib2 - make an archive of level 2 all precisions."
	@ echo " "
	@ echo "slib3 --- make an archive of level 3 REAL."
	@ echo "dlib3 --- make an archive of level 3 DOUBLE PRECISION ."
	@ echo "clib3 --- make an archive of level 3 COMPLEX."
	@ echo "zlib3 --- make an archive of level 3 COMPLEX*16."
	@ echo "alllib3 - make an archive of level 3 all precisions."
	@ echo " "
	@ echo "alllib -- make an archive for all precisions."
	@ echo " "
	@ echo "stest1 -- Compiles the tester for level 1 REAL."
	@ echo "dtest1 -- Compiles the tester for level 1 DOUBLE PRECISION. "
	@ echo "ctest1 -- Compiles the tester for level 1 COMPLEX."
	@ echo "ztest1 -- Compiles the tester for level 1 COMPLEX*16."
	@ echo "alltst1 - Compiles testers for all precisions of level 1." 
	@ echo " "
	@ echo "stest2 -- Compiles the tester for level 2 REAL."
	@ echo "dtest2 -- Compiles the tester for level 2 DOUBLE PRECISION. "
	@ echo "ctest2 -- Compiles the tester for level 2 COMPLEX."
	@ echo "ztest2 -- Compiles the tester for level 2 COMPLEX*16."
	@ echo "alltst2 - Compiles testers for all precisions of level 2." 
	@ echo " "
	@ echo "stest3 -- Compiles the tester for level 3 REAL."
	@ echo "dtest3 -- Compiles the tester for level 3 DOUBLE PRECISON. "
	@ echo "ctest3 -- Compiles the tester for level 3 COMPLEX."
	@ echo "ztest3 -- Compiles the tester for level 3 COMPLEX*16."
	@ echo "alltst3 - Compiles testers for all precisions of level 3." 
	@ echo " "
	@ echo "alltst -- Compiles testers for all CBLAS routines." 
	@ echo " "
	@ echo "all ----- Creates a library and testers for ALL." 
	@ echo " "
	@ echo "clean --- Erase all the .o and excutable files" 
	@ echo "cleanlib -- Erase all the .o  files" 
	@ echo "cleanexe -- Erase all the excutable files" 
	@ echo "rmlib --- Remove a library file." 
	@ echo " "
	@ echo "example1 -- A small example to exercise the interface "
	@ echo "example2 -- Test that cblas_xerbla() is working correctly"
	@ echo " "
	@ echo " ------- Warning ------- "
	@ echo "If you want just to make a tester, make sure you have"
	@ echo "already made an archive file out of CBLAS routines."
	@ echo " "
	@ echo "Written by Keita Teranishi"
	@ echo "3/4/98 "


# In general, the Makefile call other Makefiles in the sub-directories.

all: alllib alltst 

clean:
	( cd testing ; make clean )
	( cd src ; make clean )
	rm -f *.o cblas_ex1 cblas_ex2

cleanobj:
	( cd testing ; make cleanobj )
	( cd src ; make clean )

cleanexe:
	( cd testing ; make cleanexe )

rmlib:
	( rm -f $(CBLIB) )
slib1: $(CBLIBDIR) sreal1
dlib1: $(CBLIBDIR) dreal1
clib1: $(CBLIBDIR) scplx1
zlib1: $(CBLIBDIR) dcplx1
slib2: $(CBLIBDIR) sreal2
dlib2: $(CBLIBDIR) dreal2
clib2: $(CBLIBDIR) scplx2
zlib2: $(CBLIBDIR) dcplx2
slib3: $(CBLIBDIR) sreal3
dlib3: $(CBLIBDIR) dreal3
clib3: $(CBLIBDIR) scplx3 
zlib3: $(CBLIBDIR) dcplx3 
alllib1: $(CBLIBDIR) allprecision1
alllib2: $(CBLIBDIR) allprecision2
alllib3: $(CBLIBDIR) allprecision3
alllib: $(CBLIBDIR) allprecision

$(CBLIBDIR):
	mkdir $(CBLIBDIR)
sreal1:
	( cd src ; make slib1)
dreal1:
	( cd src ; make dlib1)
scplx1:
	( cd src ; make clib1)
dcplx1:
	( cd src ; make zlib1)
allprecision1:
	( cd src ; make all1)
sreal2:
	( cd src ; make slib2)
dreal2:
	( cd src ; make dlib2)
scplx2:
	( cd src ; make clib2)
dcplx2:
	( cd src ; make zlib2)
allprecision2:
	( cd src ; make all2)
sreal3:
	( cd src ; make slib3)
dreal3:
	( cd src ; make dlib3)
scplx3:
	( cd src ; make clib3)
dcplx3:
	( cd src ; make zlib3)
allprecision3:
	( cd src ; make all3)
allprecision:
	( cd src ; make all)

stest1: 
	( cd testing ; make stest1 )
dtest1: 
	( cd testing ; make dtest1 )
ctest1: 
	( cd testing ; make ctest1 )
ztest1: 
	( cd testing ; make ztest1 )
alltst1:
	( cd testing ; make all1 )
stest2:
	( cd testing ; make stest2 )
dtest2:
	( cd testing ; make dtest2 )
ctest2:
	( cd testing ; make ctest2 )
ztest2:
	( cd testing ; make ztest2 )
alltst2:
	( cd testing ; make all2 )
stest3:
	( cd testing ; make stest3 )
dtest3:
	( cd testing ; make dtest3 )
ctest3:
	( cd testing ; make ctest3 )
ztest3:
	( cd testing ; make ztest3 )
alltst3:
	( cd testing ; make all3 )
alltst:
	( cd testing ; make all )
   
example1: 
	$(CC) -c $(CFLAGS) -Isrc cblas_example1.c
	$(LOADER) -o cblas_ex1 cblas_example1.o $(CBLIB) $(BLLIB)

example2: 
	$(CC) -c $(CFLAGS) -Isrc cblas_example2.c
	$(LOADER) -o cblas_ex2 cblas_example2.o $(CBLIB) $(BLLIB)
   
cleanall:
	( cd src ; rm -f a.out core *.o )
	( cd testing ; rm -f a.out core *.o x[sdcz]cblat[123] )
	rm -f *.o cblas_ex1 cblas_ex2
	rm -f $(CBLIB)

=== src/Makefile ===
include make.inc

#######################################################################
#  This is the makefile to create a library for the BLAS.
#  The files are grouped as follows:
#
#       SBLAS1 -- Single precision real BLAS routines
#       CBLAS1 -- Single precision complex BLAS routines
#       DBLAS1 -- Double precision real BLAS routines
#       ZBLAS1 -- Double precision complex BLAS routines
#
#       CB1AUX -- Real BLAS routines called by complex routines
#       ZB1AUX -- D.P. real BLAS routines called by d.p. complex
#                 routines
#
#      ALLBLAS -- Auxiliary routines for Level 2 and 3 BLAS
#
#       SBLAS2 -- Single precision real BLAS2 routines
#       CBLAS2 -- Single precision complex BLAS2 routines
#       DBLAS2 -- Double precision real BLAS2 routines
#       ZBLAS2 -- Double precision complex BLAS2 routines
#
#       SBLAS3 -- Single precision real BLAS3 routines
#       CBLAS3 -- Single precision complex BLAS3 routines
#       DBLAS3 -- Double precision real BLAS3 routines
#       ZBLAS3 -- Double precision complex BLAS3 routines
#
#  The library can be set up to include routines for any combination
#  of the four precisions.  To create or add to the library, enter make
#  followed by one or more of the precisions desired.  Some examples:
#       make single
#       make single complex
#       make single double complex complex16
#  Note that these commands are not safe for parallel builds.
#
#  Alternatively, the commands
#       make all
#  or
#       make
#  without any arguments creates a library of all four precisions.
#  The name of the library is held in BLASLIB, which is set in the
#  make.inc
#
#  To remove the object files after the library is created, enter
#       make clean
#  To force the source files to be recompiled, enter, for example,
#       make single FRC=FRC
#
#---------------------------------------------------------------------
#
#  Edward Anderson, University of Tennessee
#  March 26, 1990
#  Susan Ostrouchov,  September 30, 1994
#  Julie Langou, March 2007
#
#######################################################################

all: $(BLASLIB)
 
#---------------------------------------------------------
#  Comment out the next 6 definitions if you already have
#  the Level 1 BLAS.
#---------------------------------------------------------
SBLAS1 = isamax.o sasum.o saxpy.o scopy.o sdot.o snrm2.o \
	srot.o srotg.o sscal.o sswap.o sdsdot.o srotmg.o srotm.o
$(SBLAS1): $(FRC)

CBLAS1 = scabs1.o scasum.o scnrm2.o icamax.o caxpy.o ccopy.o \
	cdotc.o cdotu.o csscal.o crotg.o cscal.o cswap.o csrot.o
$(CBLAS1): $(FRC)

DBLAS1 = idamax.o dasum.o daxpy.o dcopy.o ddot.o dnrm2.o \
	drot.o drotg.o dscal.o dsdot.o dswap.o drotmg.o drotm.o
$(DBLAS1): $(FRC)

ZBLAS1 = dcabs1.o dzasum.o dznrm2.o izamax.o zaxpy.o zcopy.o \
	zdotc.o zdotu.o zdscal.o zrotg.o zscal.o zswap.o zdrot.o
$(ZBLAS1): $(FRC)

CB1AUX = isamax.o sasum.o saxpy.o scopy.o snrm2.o sscal.o
$(CB1AUX): $(FRC)

ZB1AUX = idamax.o dasum.o daxpy.o dcopy.o dnrm2.o dscal.o
$(ZB1AUX): $(FRC)

#---------------------------------------------------------------------
#  The following line defines auxiliary routines needed by both the
#  Level 2 and Level 3 BLAS.  Comment it out only if you already have
#  both the Level 2 and 3 BLAS.
#---------------------------------------------------------------------
ALLBLAS  = lsame.o xerbla.o
$(ALLBLAS) : $(FRC)

#---------------------------------------------------------
#  Comment out the next 4 definitions if you already have
#  the Level 2 BLAS.
#---------------------------------------------------------
SBLAS2 = sgemv.o sgbmv.o ssymv.o ssbmv.o sspmv.o \
	strmv.o stbmv.o stpmv.o strsv.o stbsv.o stpsv.o \
	sger.o ssyr.o sspr.o ssyr2.o sspr2.o
$(SBLAS2): $(FRC)

CBLAS2 = cgemv.o cgbmv.o chemv.o chbmv.o chpmv.o \
	ctrmv.o ctbmv.o ctpmv.o ctrsv.o ctbsv.o ctpsv.o \
	cgerc.o cgeru.o cher.o chpr.o cher2.o chpr2.o
$(CBLAS2): $(FRC)

DBLAS2 = dgemv.o dgbmv.o dsymv.o dsbmv.o dspmv.o \
	dtrmv.o dtbmv.o dtpmv.o dtrsv.o dtbsv.o dtpsv.o \
	dger.o dsyr.o dspr.o dsyr2.o dspr2.o
$(DBLAS2): $(FRC)

ZBLAS2 = zgemv.o zgbmv.o zhemv.o zhbmv.o zhpmv.o \
	ztrmv.o ztbmv.o ztpmv.o ztrsv.o ztbsv.o ztpsv.o \
	zgerc.o zgeru.o zher.o zhpr.o zher2.o zhpr2.o
$(ZBLAS2): $(FRC)

#---------------------------------------------------------
#  Comment out the next 4 definitions if you already have
#  the Level 3 BLAS.
#---------------------------------------------------------
SBLAS3 = sgemm.o ssymm.o ssyrk.o ssyr2k.o strmm.o strsm.o 
$(SBLAS3): $(FRC)

CBLAS3 = cgemm.o csymm.o csyrk.o csyr2k.o ctrmm.o ctrsm.o \
	chemm.o cherk.o cher2k.o
$(CBLAS3): $(FRC)

DBLAS3 = dgemm.o dsymm.o dsyrk.o dsyr2k.o dtrmm.o dtrsm.o
$(DBLAS3): $(FRC)

ZBLAS3 = zgemm.o zsymm.o zsyrk.o zsyr2k.o ztrmm.o ztrsm.o \
	zhemm.o zherk.o zher2k.o
$(ZBLAS3): $(FRC)

ALLOBJ=$(SBLAS1) $(SBLAS2) $(SBLAS3) $(DBLAS1) $(DBLAS2) $(DBLAS3)	\
	$(CBLAS1) $(CBLAS2) $(CBLAS3) $(ZBLAS1) 	\
	$(ZBLAS2) $(ZBLAS3) $(ALLBLAS)

$(BLASLIB): $(ALLOBJ)
	$(ARCH) $(ARCHFLAGS) $@ $(ALLOBJ)
	$(RANLIB) $@

single: $(SBLAS1) $(ALLBLAS) $(SBLAS2) $(SBLAS3)
	$(ARCH) $(ARCHFLAGS) $(BLASLIB) $(SBLAS1) $(ALLBLAS) \
	$(SBLAS2) $(SBLAS3)
	$(RANLIB) $(BLASLIB)

double: $(DBLAS1) $(ALLBLAS) $(DBLAS2) $(DBLAS3)
	$(ARCH) $(ARCHFLAGS) $(BLASLIB) $(DBLAS1) $(ALLBLAS) \
	$(DBLAS2) $(DBLAS3)
	$(RANLIB) $(BLASLIB)

complex: $(CBLAS1) $(CB1AUX) $(ALLBLAS) $(CBLAS2) $(CBLAS3)
	$(ARCH) $(ARCHFLAGS) $(BLASLIB) $(CBLAS1) $(CB1AUX) \
	$(ALLBLAS) $(CBLAS2) $(CBLAS3)
	$(RANLIB) $(BLASLIB)

complex16: $(ZBLAS1) $(ZB1AUX) $(ALLBLAS) $(ZBLAS2) $(ZBLAS3)
	$(ARCH) $(ARCHFLAGS) $(BLASLIB) $(ZBLAS1) $(ZB1AUX) \
	$(ALLBLAS) $(ZBLAS2) $(ZBLAS3)
	$(RANLIB) $(BLASLIB)

FRC:
	@FRC=$(FRC)

clean:
	rm -f *.o

.f.o: 
	$(FORTRAN) $(OPTS) -c $< -o $@

=== cblas/testing/Makefile ===
#
# The Makefile compiles c wrappers and testers for CBLAS.  
#

dlvl = ../.
include $(dlvl)/Makefile.in
INC = -I$(CBDIR)/src

# Archive files necessary to compile
LIB = $(CBLIB) $(BLLIB) 

# Object files for single real precision
stestl1o = c_sblas1.o

stestl2o = c_sblas2.o c_s2chke.o auxiliary.o c_xerbla.o

stestl3o = c_sblas3.o c_s3chke.o auxiliary.o c_xerbla.o

# Object files for double real precision
dtestl1o = c_dblas1.o

dtestl2o = c_dblas2.o c_d2chke.o auxiliary.o c_xerbla.o

dtestl3o = c_dblas3.o c_d3chke.o auxiliary.o c_xerbla.o

# Object files for single complex precision
ctestl1o = c_cblas1.o

ctestl2o = c_cblas2.o c_c2chke.o auxiliary.o c_xerbla.o

ctestl3o = c_cblas3.o c_c3chke.o auxiliary.o c_xerbla.o

# Object files for double complex precision
ztestl1o = c_zblas1.o 

ztestl2o = c_zblas2.o c_z2chke.o auxiliary.o c_xerbla.o

ztestl3o = c_zblas3.o c_z3chke.o auxiliary.o c_xerbla.o

all1: stest1 dtest1 ctest1 ztest1 
all2: stest2 dtest2 ctest2 ztest2
all3: stest3 dtest3 ctest3 ztest3
all: all1 all2 all3 

clean:
	rm -f core *.o a.out x*
cleanobj:
	rm -f core *.o a.out 
cleanexe:
	rm -f x* 

stest1: xscblat1
dtest1: xdcblat1
ctest1: xccblat1
ztest1: xzcblat1

stest2: xscblat2
dtest2: xdcblat2
ctest2: xccblat2
ztest2: xzcblat2

stest3: xscblat3
dtest3: xdcblat3
ctest3: xccblat3
ztest3: xzcblat3

#
# Compile each precision
#

# Single real
xscblat1: $(stestl1o) c_sblat1.o
	$(LOADER) $(LOADFLAGS) -o xscblat1 c_sblat1.o $(stestl1o) $(LIB)
xscblat2: $(stestl2o) c_sblat2.o
	$(LOADER) $(LOADFLAGS) -o xscblat2 c_sblat2.o $(stestl2o) $(LIB)
xscblat3: $(stestl3o) c_sblat3.o
	$(LOADER) $(LOADFLAGS) -o xscblat3 c_sblat3.o $(stestl3o) $(LIB)
# Double real
xdcblat1: $(dtestl1o) c_dblat1.o
	$(LOADER) $(LOADFLAGS) -o xdcblat1 c_dblat1.o $(dtestl1o) $(LIB)
xdcblat2: $(dtestl2o) c_dblat2.o
	$(LOADER) $(LOADFLAGS) -o xdcblat2 c_dblat2.o $(dtestl2o) $(LIB)
xdcblat3: $(dtestl3o) c_dblat3.o
	$(LOADER) $(LOADFLAGS) -o xdcblat3 c_dblat3.o $(dtestl3o) $(LIB)
 
# Single complex
xccblat1: $(ctestl1o) c_cblat1.o
	$(LOADER) $(LOADFLAGS) -o xccblat1 c_cblat1.o $(ctestl1o) $(LIB)
xccblat2: $(ctestl2o) c_cblat2.o
	$(LOADER) $(LOADFLAGS) -o xccblat2 c_cblat2.o $(ctestl2o) $(LIB)
xccblat3: $(ctestl3o) c_cblat3.o
	$(LOADER) $(LOADFLAGS) -o xccblat3 c_cblat3.o $(ctestl3o) $(LIB)

# Double complex 
xzcblat1: $(ztestl1o) c_zblat1.o
	$(LOADER) $(LOADFLAGS) -o xzcblat1 c_zblat1.o $(ztestl1o) $(LIB)
xzcblat2: $(ztestl2o) c_zblat2.o
	$(LOADER) $(LOADFLAGS) -o xzcblat2 c_zblat2.o $(ztestl2o) $(LIB)
xzcblat3: $(ztestl3o) c_zblat3.o
	$(LOADER) $(LOADFLAGS) -o xzcblat3 c_zblat3.o $(ztestl3o) $(LIB)
   
.SUFFIXES: .o .f .c

.f.o:
	$(FC) $(FFLAGS) -c $*.f
.c.o:
	$(CC) $(INC) $(CFLAGS) -c $*.c

=== debian/changelog ===
blas (1.2.20110419-7ubuntu1) utopic; urgency=medium

  * Cherry-pick from Debian blas 1.2.20110419-9 to fix FTBFS on i386;
    thanks to Sébastien Villemot:
    - On any-i386 and m68k, compile test programs with -ffloat-store. This
      has become necessary with gfortran 4.9 (maybe because the
      -fno-whole-file option has been removed, though I don't really
      understand the interaction of both options). (Closes: #762484)

 -- Robie Basak <robie.basak@ubuntu.com>  Wed, 08 Oct 2014 15:22:19 +0000

blas (1.2.20110419-7) unstable; urgency=low

  * Make sure that -mieee is used when compiling on alpha
  * Restore -fno-whole-file and -ffloat-store (the latter only for *-i386
    and m68k, and only for some files), otherwise some tests break

 -- Sébastien Villemot <sebastien@debian.org>  Tue, 24 Sep 2013 20:41:52 +0200

blas (1.2.20110419-6) unstable; urgency=low

  * Use my @debian.org address
  * Remove obsolete DM-Upload-Allowed flag
  * Bump to debhelper compat level 9
  * Remove pre-squeeze Conflicts/Replaces/Provides
  * Use quilt to manage the patch to upstream sources
  * Rewrite debian/rules using dh
  * Test programs are now installed under /usr/lib/libblas, for consistency with
    the library objects
  * Inject flags from dpkg-buildflags (Closes: #700495)
  * Switch VCS to git
  * Improve long description of libblas-test
  * Bump to Standards-Version 3.9.4, no changes needed
  * Ship in libblas-test a script for running all BLAS tests
  * Register cinterface.pdf into doc-base, and fix the doc-base section
    for the BLAS FAQ

 -- Sébastien Villemot <sebastien@debian.org>  Mon, 23 Sep 2013 18:56:25 +0200

blas (1.2.20110419-5) unstable; urgency=low

  * libblas3gf.prerm: avoid crash if libblas.so.3gf already deleted
  * libblas-test: put in devel/extra to reflect override

 -- Sébastien Villemot <sebastien.villemot@ens.fr>  Fri, 29 Jun 2012 18:37:36 +0000

blas (1.2.20110419-4) unstable; urgency=low

  * libblas3.prerm: avoid crash if libblas.so.3gf already deleted
  * Indicate that libblas3 conflicts with octave3.2 (Closes: #677399)
  * libblas3gf transitional package:
    + move to oldlibs section (Closes: #679104)
    + mark as arch:all
  * Add myself to Uploaders
  * Set DM-Upload-Allowed to yes

 -- Sébastien Villemot <sebastien.villemot@ens.fr>  Sun, 24 Jun 2012 16:13:14 +0000

blas (1.2.20110419-3) unstable; urgency=low

  * Upload in unstable

 -- Sylvestre Ledru <sylvestre@debian.org>  Sat, 02 Jun 2012 17:32:35 +0200

blas (1.2.20110419-3~exp8) experimental; urgency=low

  * Rollback previous upload

 -- Sylvestre Ledru <sylvestre@debian.org>  Fri, 01 Jun 2012 11:04:21 +0200

blas (1.2.20110419-3~exp7) experimental; urgency=low

  * Fix a bad alternative link to the old library name

 -- Sylvestre Ledru <sylvestre@debian.org>  Fri, 01 Jun 2012 10:27:10 +0200

blas (1.2.20110419-3~exp6) experimental; urgency=low

  * Replaces and Breaks updated against the right versions of other impacted
    packages

 -- Sylvestre Ledru <sylvestre@debian.org>  Sun, 20 May 2012 17:20:39 +0200

blas (1.2.20110419-3~exp5) experimental; urgency=low

  * Moved removal from postinst to preinst

 -- Sylvestre Ledru <sylvestre@debian.org>  Fri, 18 May 2012 16:01:51 +0200

blas (1.2.20110419-3~exp4) experimental; urgency=low

  * Remove libblas.so.3gf references before the install (Closes: #659784)

 -- Sylvestre Ledru <sylvestre@debian.org>  Mon, 14 May 2012 18:29:00 +0200

blas (1.2.20110419-3~exp3) experimental; urgency=low

  * Join modifications with blas, lapack, atlas and openblas.
    Declare the replacements of all *3gf blas & lapack implementation
    (See bug #660607)
  * Standards-Version updated to version 3.9.3
  * -fwhole-file, default from gfortran 4.6, is breaking the blas tests.
    Bring back the previous behavior with -fno-whole-file
  * Update of the desc

 -- Sylvestre Ledru <sylvestre@debian.org>  Tue, 10 Apr 2012 21:10:42 +0200

blas (1.2.20110419-3~exp2) experimental; urgency=low

  * Bring back libblas3gf as transitionnal package
  * Drop the previous alternative before installing the new one
    (Closes: #659784)
  * Drop the forced version of gcc (Closes: #654723)

 -- Sylvestre Ledru <sylvestre@debian.org>  Sun, 19 Feb 2012 12:02:10 +0100

blas (1.2.20110419-3~exp1) experimental; urgency=low

  * Rename libblas3gf package => libblas3
  * Rename libblas.so.3gf => libblas.so.3
  * Fix postinst-has-useless-call-to-ldconfig &
    postrm-has-useless-call-to-ldconfig
  * Fix debian-rules-missing-recommended-target build-arch

 -- Sylvestre Ledru <sylvestre@debian.org>  Sun, 04 Sep 2011 14:42:02 +0200

blas (1.2.20110419-2) unstable; urgency=low

  * Force the version 4.5 of gcc to fix a failing test (Closes: #625723)
  * -O3 is set back for amd64 (Closes: #569436)

 -- Sylvestre Ledru <sylvestre@debian.org>  Wed, 10 Aug 2011 23:32:26 +0200

blas (1.2.20110419-1) unstable; urgency=low

  * New upstream release
    - Fix the FTBFS due to changes in the returned values (Closes: #625723)
      (LP: #765998)
  * Switch to dpkg-source 3.0 (quilt) format
  * Standards-Version updated to version 3.9.2

 -- Sylvestre Ledru <sylvestre@debian.org>  Fri, 05 Aug 2011 00:40:45 +0200

blas (1.2-8) unstable; urgency=low

  [ Kumar Appaiah ]
  * Use 'findstring' in rules file to search for amd64 within
    architecture string to use -O2 as FFLAGS. (Closes: #598876)

 -- Sylvestre Ledru <sylvestre@debian.org>  Tue, 05 Oct 2010 15:08:35 +0200

blas (1.2-7) unstable; urgency=low

  * Remove the old alternatives (Closes: #576801)

 -- Sylvestre Ledru <sylvestre@debian.org>  Wed, 07 Apr 2010 14:50:51 +0200

blas (1.2-6) unstable; urgency=low

  * Upload into unstable

 -- Sylvestre Ledru <sylvestre@debian.org>  Tue, 06 Apr 2010 10:21:37 +0200

blas (1.2-5) experimental; urgency=low

  * postinst & prerm added for each packages to manage update-alternatives
    See: http://wiki.debian.org/DebianScience/LinearAlgebraLibraries



=== debian/control ===
Source: blas
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Science Team <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Sylvestre Ledru <sylvestre@debian.org>,
           Sébastien Villemot <sebastien@debian.org>
Standards-Version: 3.9.4
Build-Depends: gfortran, debhelper (>= 9)
Build-Depends-Indep: texlive-latex-recommended
Section: libs
Homepage: http://www.netlib.org/blas/
Vcs-Git: git://anonscm.debian.org/debian-science/packages/blas.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=debian-science/packages/blas.git

Package: libblas3
Architecture: any
Provides: libblas.so.3gf, libblas3gf, libblas.so.3
Depends: ${shlibs:Depends}, ${misc:Depends}
Replaces: libblas3gf (<< 1.2.20110419-3), libatlas3gf-base (<< 3.8.4-4),
 libopenblas-base (<< 0.1.1-3)
Breaks: libblas3gf (<< 1.2.20110419-3), libatlas3gf-base (<< 3.8.4-4),
 libopenblas-base (<< 0.1.1-3)
Conflicts: octave3.2
Description: Basic Linear Algebra Reference implementations, shared library
 BLAS (Basic Linear Algebra Subroutines) is a set of efficient
 routines for most of the basic vector and matrix operations. 
 They are widely used as the basis for other high quality linear
 algebra software, for example lapack and linpack.  This 
 implementation is the Fortran 77 reference implementation found
 at netlib. 
 .
 This package contains a shared version of the library.

Package: libblas3gf
Architecture: all
Section: oldlibs
Depends: ${misc:Depends}, libblas3
Description: Transitional package for libblas
 Several minor changes to the C interface have been incorporated. 
 One can maintain both versions on a system simultaneously to aid 
 in the transition.

Package: libblas-dev
Architecture: any
Section: libdevel
Provides: libblas.so
Depends: libblas3 (= ${binary:Version}), ${misc:Depends}
Description: Basic Linear Algebra Subroutines 3, static library
 This package is a binary incompatible upgrade to the blas-dev
 package. Several minor changes to the C interface have been
 incorporated. 
 .	
 BLAS (Basic Linear Algebra Subroutines) is a set of efficient
 routines for most of the basic vector and matrix operations.
 They are widely used as the basis for other high quality linear
 algebra software, for example lapack and linpack.  This 
 implementation is the Fortran 77 reference implementation found
 at netlib. 
 .
 This package contains a static version of the library.

Package: libblas-test
Architecture: any
Section: devel
Priority: extra
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Basic Linear Algebra Subroutines 3, testing programs
 BLAS (Basic Linear Algebra Subroutines) is a set of efficient
 routines for most of the basic vector and matrix operations.
 They are widely used as the basis for other high quality linear
 algebra software, for example lapack and linpack.  This 
 implementation is the Fortran 77 reference implementation found
 at netlib. 
 .
 This package contains a set of programs which test the integrity of an
 installed blas-compatible shared library. These programs may therefore be used
 to test the libraries provided by the blas package as well as those provided
 by the libatlas3-base and libopenblas-base packages. The programs are
 dynamically linked -- one can explicitly select a library to test by setting
 the libblas.so.3 alternative, or by using the LD_LIBRARY_PATH or LD_PRELOAD
 environment variables. Likewise, one can display the library selected using
 the ldd program in an identical environment.

Package: libblas-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Description: Basic Linear Algebra Subroutines 3, documentation
 BLAS (Basic Linear Algebra Subroutines) is a set of efficient
 routines for most of the basic vector and matrix operations.
 They are widely used as the basis for other high quality linear
 algebra software, for example lapack and linpack.  This 
 implementation is the Fortran 77 reference implementation found
 at netlib. 
 .
 This package contains manual pages for the routines, and other
 supporting documentation

=== debian/rules ===
#!/usr/bin/make -f

# xerblas_ and LAPACK_xerblas must be overrideable by applications
# --dynamic-list does not work with gold, so drop the flag completely
BUILDFLAGS_ENV:=DEB_LDFLAGS_MAINT_STRIP="-Wl,-Bsymbolic-functions"
LDFLAGS:=$(shell $(BUILDFLAGS_ENV) dpkg-buildflags --get LDFLAGS)

F77:=gfortran
FFLAGS:=$(shell dpkg-buildflags --get FFLAGS)

CC:=cc
CFLAGS:=$(shell dpkg-buildflags --get CFLAGS)
CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)

ARCH:=$(shell dpkg --print-architecture)
CPU:=$(shell dpkg-architecture -qDEB_HOST_ARCH_CPU)

ifeq ($(ARCH),alpha)
  FFLAGS += -mieee
endif

# Necessary to avoid test failures
ifneq (,$(filter $(CPU),i386 m68k))
  FFLAGS_EXTRA := -ffloat-store
endif


SO=3
VERS=$(SO).0

VN:=$(shell pwd)
VO:=$(VN).orig
UD:=$(shell dirname $$(pwd))

PDF:=cinterface
PDD:=debian/patched-docs
PDP:=$(addprefix $(PDD)/,$(PDF))
PDS:=$(addsuffix .tex,$(PDP))
PDO:=$(addsuffix .pdf,$(PDP))

# Support parallel build                                                                                                                                                                
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))                                                                                                     
	MAKEFLAGS += -j$(NUMJOBS)                                                                                                                                                        
endif


# Rules for recreating the source tarball
# TODO: fix the rules and convert them to a get-orig-source rule

$(UD)/blas.tgz:
	mkdir -p $(@D)
	cd $(@D) && wget -N ftp://ftp.netlib.org/blas/$(@F)

$(UD)/cblas.tgz:
	mkdir -p $(@D)
	cd $(@D) && wget -N ftp://ftp.netlib.org/blas/blast-forum/$(@F)

$(UD)/manpages.tgz:
	mkdir -p $(@D)
	cd $(@D) && wget -N ftp://ftp.netlib.org/lapack/$(@F)

$(VO)/src: $(UD)/blas.tgz
	mkdir -p $@
	cd $@ && tar zxf $<

TF:=s d c z
TF:=$(addsuffix blat1,$(TF)) $(addsuffix blat2,$(TF)) $(addsuffix blat3,$(TF)) \
	$(addsuffix blat2d,$(TF)) $(addsuffix blat3d,$(TF))

$(addprefix $(VO)/test/,$(TF)):
	mkdir -p $(@D)
	cd $(@D) && wget -N ftp://ftp.netlib.org/blas/$(@F)

$(VO)/test: $(addprefix $(VO)/test/,$(TF))

$(VO)/man: $(UD)/manpages.tgz
	mkdir -p $(@D)
	cd $(VO) && tar zxf $< blas
	rm -rf $@
	mv $(VO)/blas/man $@
	rmdir $(VO)/blas

$(VO)/cblas: $(UD)/cblas.tgz
	cd $(VO) && tar zxf $<
	rm -rf $@
	mv $(VO)/CBLAS $@

DF:=faq.html 
$(addprefix $(VO)/doc/,$(DF)):
	mkdir -p $(@D)
	cd $(@D) && wget -N ftp://ftp.netlib.org/blas/$(@F)

$(VO)/doc/cinterface.pdf:
	mkdir -p $(@D)
	cd $(@D) && wget -N ftp://ftp.netlib.org/blas/blast-forum/$(@F)

$(VO)/doc/blue.gif:
	mkdir -p $(@D)
	cd $(@D) && wget -N ftp://ftp.netlib.org/scalapack/html/gif/$(@F)

%.png: %.gif
	gif2png $<

$(VO)/doc: $(addprefix $(VO)/doc/,$(DF)) $(VO)/doc/blue.png

ori: $(addprefix $(VO)/,src test man cblas doc)


# Compilation rules

BSRC:=$(shell echo src/*.f)
BOBJ:=$(BSRC:.f=.o)
BOBJ1:=$(filter-out src/izamax.o,$(filter-out src/icamax.o,$(BOBJ)))
BOBJ2:=src/icamax.o src/izamax.o

debian/shared_dir debian/static_dir debian/test_dir:
	mkdir -p $(subst _dir,,$(@))
	touch $@

$(subst src/,debian/static/,$(BOBJ1)): \
	debian/static/%.o : src/%.f debian/static_dir

	$(F77) $(FFLAGS) -c $< -o $@	

$(subst src/,debian/shared/,$(BOBJ1)): \
	debian/shared/%.o : src/%.f debian/shared_dir

	$(F77) $(FFLAGS) -fPIC -c $< -o $@	

$(subst src/,debian/static/,$(BOBJ2)): \
	debian/static/%.o : src/%.f debian/static_dir

	$(F77) $(FFLAGS) $(FFLAGS_EXTRA) -c $< -o $@	

$(subst src/,debian/shared/,$(BOBJ2)): \
	debian/shared/%.o : src/%.f debian/shared_dir

	$(F77) $(FFLAGS) $(FFLAGS_EXTRA) -fPIC -c $< -o $@	

libblas.a: cblas/libcblas.a $(subst src/,debian/static/,$(BOBJ)) debian/static_dir
	cd debian/static && ar x ../../$<
	ar r $@ debian/static/*.o

libblas.so.$(VERS): cblas/libcblas_pic.a $(subst src/,debian/shared/,$(BOBJ)) debian/shared_dir
	cd debian/shared && ar x ../../$<
	$(F77) $(LDFLAGS) -shared -Wl,-soname=libblas.so.$(SO) -o $@ debian/shared/*.o

libblas.so.$(SO): libblas.so.$(VERS)
	ln -snf $< $@

libblas.so: libblas.so.$(SO)
	ln -snf $< $@

cblas/Makefile.in: cblas/Makefile.LINUX
	cat $< | sed -e "s,^BLLIB = .*,BLLIB = -L $$(pwd) -lblas,1" \
		     -e "s,^CBDIR = .*,CBDIR = $$(pwd)/cblas,1" \
		     -e "s,^CC = .*,CC = $(CC) ,1" \
		     -e "s,^FC = .*,FC = $(F77) ,1" \
		     -e "s,^CFLAGS = .*,CFLAGS = $(CPPFLAGS) $(CFLAGS) \$$(PICOPTS) -DADD_,1" \
		     -e "s,^FFLAGS = .*,FFLAGS = $(FFLAGS) \$$(PICOPTS) ,1" \
			>$@
	echo "LOADFLAGS = $(LDFLAGS)" >>$@

cblas/libcblas.a: cblas/Makefile.in
	cd $(@D) && $(MAKE) cleanobj 
	cd $(@D) && $(MAKE) rmlib
	mkdir -p cblas/lib/LINUX
	cd $(@D) && $(MAKE) alllib
	cp cblas/lib/LINUX/cblas_LINUX.a $@

cblas/libcblas_pic.a: cblas/Makefile.in
	cd $(@D) && $(MAKE) cleanobj 
	cd $(@D) && $(MAKE) rmlib
	mkdir -p cblas/lib/LINUX
	cd $(@D) && $(MAKE) PICOPTS=-fPIC alllib
	cp cblas/lib/LINUX/cblas_LINUX.a $@

BIN:=s d c z
BIN:=$(addsuffix cblat1,$(BIN)) $(addsuffix cblat2,$(BIN)) $(addsuffix cblat3,$(BIN))
BIN:=$(addprefix cblas/testing/x,$(BIN))

$(BIN): libblas.so
	cd cblas && $(MAKE) alltst CBLIB= FFLAGS="$(FFLAGS) $(FFLAGS_EXTRA)"

FBN:=s d c z
FBN:=$(addsuffix blat1,$(FBN)) $(addsuffix blat2,$(FBN)) $(addsuffix blat3,$(FBN))
FBN:=$(addprefix test/x,$(FBN))

test/%.f: test/%
	cp $< $@

test/x%: test/%.f libblas.so 
	$(F77) $(FFLAGS) $(FFLAGS_EXTRA) $(LDFLAGS) -o $@ $< -L $$(pwd) -lblas

OUT:=$(subst cblas/testing/,debian/test/,$(BIN))
OUT1:=$(filter %1,$(OUT))
OUT23:=$(filter-out %1,$(OUT))

$(OUT1): \
	debian/test/%: cblas/testing/% debian/test_dir libblas.so
	LD_LIBRARY_PATH=$$(pwd):$$LD_LIBRARY_PATH $< > $@
	awk '/fail/ || /FAIL/ {exit 1}' $@ || (cat $@ && false)

$(OUT23): \
	debian/test/%: cblas/testing/% debian/test_dir libblas.so
	LD_LIBRARY_PATH=$$(pwd):$$LD_LIBRARY_PATH $< \
		< cblas/testing/$(subst x,,$(subst cblat,in,$*)) > $@
	awk '/fail/ || /FAIL/ {exit 1}' $@ || (cat $@ && false)

FOT:=$(subst test/,debian/test/,$(FBN))
FOT1:=$(filter %1,$(FOT))
FOT23:=$(filter-out %1,$(FOT))

$(FOT1): \
	debian/test/%: test/% debian/test_dir libblas.so
	LD_LIBRARY_PATH=$$(pwd):$$LD_LIBRARY_PATH $< > $@
	awk '/fail/ || /FAIL/ {exit 1}' $@ || (cat $@ && false)

$(FOT23): \
	debian/test/%: test/% debian/test_dir libblas.so
	rm -f *.SUMM
	LD_LIBRARY_PATH=$$(pwd):$$LD_LIBRARY_PATH $< \
		< test/$(subst x,,$*)d
	cat *.SUMM >$@
	awk '/fail/ || /FAIL/ {exit 1}' $@ || (cat $@ && false)

debian/test_results: $(OUT) $(FOT)
	cat $^ > $@
	cat $@ | awk '/fail/ || /FAIL/ {exit 1}'

MFL:=$(shell echo man/manl/*)
%.3: %.l
	cat $< | sed "s,^.TH  *\([^ ]*\)  *l  *\(.*\),.TH \1 3 \2,1" >$@
	echo Converted $< to $@, diff: 
	diff -u $< $@ || true
MF:=$(subst .l,.3,$(MFL))

$(PDO): %.pdf: %.tex
	cd $(@D) && pdflatex $(<F) && pdflatex $(<F)


# Packaging rules

%:
	dh $@ --parallel

override_dh_auto_build-arch: libblas.so libblas.a $(BIN) $(FBN)

override_dh_auto_build-indep: $(MF) $(PDO)

ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
override_dh_auto_test-arch: debian/test_results
else
override_dh_auto_test-arch:
	touch debian/test_results
endif

override_dh_auto_clean: cblas/Makefile.in
	dh_testdir
	dh_testroot
	rm -f build-stamp
	rm -f debian/static/* debian/shared/* test/x* test/*.f libblas* cblas/libcblas* man/manl/*.3
	rm -f *SUMM
	rm -rf debian/test* debian/shared* debian/static*
	cd $(PDD) && rm -rf *.pdf *.log *.aux *.ps *.dvi

	-rm -rf static shared
	cd cblas && $(MAKE) clean && $(MAKE) rmlib
	rm -f $<

override_dh_installman-indep:
	dh_installman -p libblas-doc man/manl/*.3

override_dh_installman-arch:
	dh_installman -p libblas-test debian/*.1

override_dh_makeshlibs:
	dh_makeshlibs -a -V "libblas3 | libblas.so.3" -n

override_dh_shlibdeps:
	dh_shlibdeps -a -l $$(pwd)


.PHONY: $(addprefix $(UD)/,blas.tgz cblas.tgz manpages.tgz)
.SUFFIXES:
.INTERMEDIATE: $(VO)/doc/blue.gif

# This Makefile must be run serially (because non-PIC and PIC versions must be
